<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wwf_rights_control');
    if(!$perm['r']) die($parser->gt('not_perms'));

    include_once(SYS_BASE_PATH.'main/classes/wcatalog.class.php');
    class wtablecard extends wCatalog
    {
        public $perm = array('c' => 0, 'r' => 0, 'u' => 0, 'd' => 0);
        public function _titleframe()
        {
            global $parser;
            $this->title = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wwf_wfcase'", '');
            $this->f = new wworkflow_models_wfcase();
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;
            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';
            $mastertype = (isset($_REQUEST['mastertype'])) ? $_REQUEST['mastertype'] : '';
            $masterid = (isset($_REQUEST['masterid'])) ? $_REQUEST['masterid'] : '';
            $this->addHidden('mastertype', $mastertype);
            $this->addHidden('masterid', $masterid);
            $this->addHidden('callbackfunc', $callbackfunc);
            $this->addMenu(0, $parser->gt('card'), !$active_tab);
            $this->addMenu(1, $parser->gt('operations'), ($active_tab == 1));
            $this->addMenu(2, $parser->gt('scheme'), ($active_tab == 2));
            $this->addMenu(3, $parser->gt('log'), ($active_tab == 3));

        }

        public function _content()
        {
            global $parser;
            $cat_id = (isset($_REQUEST['cat_id'])) ? $_REQUEST['cat_id'] : '';
            $objid = (isset($_REQUEST['objid'])) ? $_REQUEST['objid'] : '';
            $card_onload_par = (isset($_REQUEST['card_onload_par'])) ? $_REQUEST['card_onload_par'] : '';
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : '';
            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';
            if(!$this->adding and !$cat_id) return $parser->gt('no_data_found');

            switch($active_tab)
            {
                case 0:
                    $parser->addScript(SYS_BASE_URL.'main/js/popup.js');

                    $f = new wworkflow_models_wfcase($this->objtype, $cat_id);
                    $f->id = $cat_id;
                    $f->buttonpanel = 'buttonpanelm';
                    $f->only_card = true;
                    $f->container = 'wwf_wfcase_cat';
                    $form_action = (isset($_POST['form_action'])) ? $_POST['form_action'] : '';
                    switch($form_action)
                    {
                        case 'edit':
                            $f->read();
                            $s = $f->update(true);
                            if($s) $f->error_mess = $s;
                            if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                        break;
                        case 'insert':
                            $s = $f->insert(true);
                            if($s) $f->error_mess = $s;
                            else
                            {
                                if($card_onload_par) $f->onCopy($card_onload_par);
                                if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                                return "<SCRIPT LANGUAGE=\"JavaScript\">navigatetoid('".$f->id."');</SCRIPT>";
                            }
                        break;
                    }

                    $f->addHidden('cat_id', $cat_id);
                    $f->addHidden('active_tab', $active_tab);
                    $f->addHidden('callbackfunc', $callbackfunc);
                    $parser->addScript("<script type='text/javascript'>
                    function form_submit()
                    {
                        $('#form_dialog_".$f->container."').submit();
                    }
                    </script>");
                    $f->en_autocomplete = true;
                    if($cat_id)
                    {
                        if($this->perm['u'])
                        {
                            $f->addHidden('form_action', 'edit');
                            $f->addButton($parser->gt('save'), 'form_submit()', 'submitbutton', 'button');
                        }
                    } else
                    {
                        if($this->perm['c'])
                        {
                            if($card_onload_par) $f->onBeforeCopy($card_onload_par);
                            $mastertype = (isset($_REQUEST['mastertype'])) ? $_REQUEST['mastertype'] : '';
                            $masterid = (isset($_REQUEST['masterid'])) ? $_REQUEST['masterid'] : '';
                            if($masterid)
                            {
                                $f->setFieldVal('wfid', $masterid);
                                $f->fields->wfid->refval =  $parser->utils->getFieldFromSql('SELECT title FROM wwf_wflow WHERE id='.$masterid, '');
                            }
                            $f->addHidden('form_action', 'insert');
                            $f->addHidden('card_onload_par', $card_onload_par);
                            $f->addButton($parser->gt('insert'), 'form_submit()', 'submitbutton', 'button');
                            $f->addButton($parser->gt('cancel'), "navigateto('last')", '', 'button');
                        }
                    }

                    return $f->showForm();
                break;
                case 1: // log
                    $objtype = 'wwf_wfcase';
                    include_once(SYS_BASE_PATH.'ext/wworkflow/lib/wfoperlist.php');
                break;
                case 2:
                    if(!$cat_id) return '';
                    if(!$this->perm['r']) return $parser->gt('not_perms');
                    $wfid = $parser->utils->getFieldFromSql('SELECT wfid FROM wwf_wfcase WHERE id='.$cat_id, '');
                    print("<iframe src=\"".$parser->makeUrl('wwf_wfcase_schema', 'wfid='.
                    $wfid.'&objtype=&objid=&caseid='.$cat_id)."\"  style=\"border: 1px solid #c0c0c0;width:100%;height:800px\"></iframe>");
                break;

                case 3: // log
                    $objtype = 'wwf_wfcase';
                    include_once(SYS_BASE_PATH.'main/system/log.php');
                break;
            }
        }
    }

    $cat = new wtablecard('wwf_wfcase');
    $cat->notreeframe = true;
    $cat->navigation = true;
    $cat->navibuttons = true;
    $cat->extra_from = '';
    $cat->extra_where = '';
    $cat->adding = $perm['c'];
    $cat->deleting = $perm['d'];
    $cat->perm = $perm;

    $cat->showTable(0);

?>