<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wftranscard');
    if(!$perm['r']) die($parser->gt('not_perms'));

    include_once(SYS_BASE_PATH.'main/classes/wcatalog.class.php');
    class wtablecard extends wCatalog
    {
        public $perm = array('c' => 0, 'r' => 0, 'u' => 0, 'd' => 0);
        public function _titleframe()
        {
            global $parser;
            $this->title = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wwf_wftrans'", '');
            $this->f = new wworkflow_models_wftrans();
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;
            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';
            $mastertype = (isset($_REQUEST['mastertype'])) ? $_REQUEST['mastertype'] : '';
            $masterid = (isset($_REQUEST['masterid'])) ? $_REQUEST['masterid'] : '';
            $this->addHidden('mastertype', $mastertype);
            $this->addHidden('masterid', $masterid);
            $this->addHidden('callbackfunc', $callbackfunc);
            $this->addMenu(0, $parser->gt('card'), !$active_tab);
            $this->addMenu(1, $parser->gt('connections'), ($active_tab == 1));
            $this->addMenu(2, $parser->gt('files'), ($active_tab == 2));
            $this->addMenu(3, $parser->gt('log'), ($active_tab == 3));
        }

        public function _content()
        {
            global $parser;
            $cat_id = (isset($_REQUEST['cat_id'])) ? $_REQUEST['cat_id'] : '';
            $objid = (isset($_REQUEST['objid'])) ? $_REQUEST['objid'] : '';
            $card_onload_par = (isset($_REQUEST['card_onload_par'])) ? $_REQUEST['card_onload_par'] : '';
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : '';
            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';
            if(!$this->adding and !$cat_id) return $parser->gt('no_data_found');

            switch($active_tab)
            {
                case 0:
                    $parser->addScript(SYS_BASE_URL.'main/js/popup.js');

                    $f = new wworkflow_models_wftrans($this->objtype, $cat_id);
                    $f->id = $cat_id;
                    $f->buttonpanel = 'buttonpanelm';
                    $f->only_card = true;
                    $f->container = 'wwf_wftrans_cat';
                    $form_action = (isset($_POST['form_action'])) ? $_POST['form_action'] : '';
                    switch($form_action)
                    {
                        case 'edit':
                            $f->read();
                            $s = $f->update(true);
                            if($s) $f->error_mess = $s;
                            if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                        break;
                        case 'insert':
                            $s = $f->insert(true);
                            if($s) $f->error_mess = $s;
                            else
                            {
                                if($card_onload_par) $f->onCopy($card_onload_par);
                                if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                                return "<SCRIPT LANGUAGE=\"JavaScript\">navigatetoid('".$f->id."');</SCRIPT>";
                            }
                        break;
                    }

                    $f->addHidden('cat_id', $cat_id);
                    $f->addHidden('active_tab', $active_tab);
                    $f->addHidden('callbackfunc', $callbackfunc);
                    $parser->addScript("<script type='text/javascript'>
                    function form_submit()
                    {
                        $('#form_dialog_".$f->container."').submit();
                    }
                    </script>");
                    $f->en_autocomplete = true;
                    if($cat_id)
                    {
                        if($this->perm['u'])
                        {
                            $f->addHidden('form_action', 'edit');
                            $f->addButton($parser->gt('save'), 'form_submit()', 'submitbutton', 'button');
                        }
                    } else
                    {
                        if($this->perm['c'])
                        {
                            if($card_onload_par) $f->onBeforeCopy($card_onload_par);
                            $mastertype = (isset($_REQUEST['mastertype'])) ? $_REQUEST['mastertype'] : '';
                            $masterid = (isset($_REQUEST['masterid'])) ? $_REQUEST['masterid'] : '';
                            if($masterid)
                            {
                                $f->setFieldVal('wfid', $masterid);
                                $f->fields->wfid->refval =  $parser->utils->getFieldFromSql('SELECT title FROM wwf_wflow WHERE id='.$masterid, '');
                            }
                            $f->addHidden('form_action', 'insert');
                            $f->addHidden('card_onload_par', $card_onload_par);
                            $f->addButton($parser->gt('insert'), 'form_submit()', 'submitbutton', 'button');
                            $f->addButton($parser->gt('cancel'), "navigateto('last')", '', 'button');
                        }
                    }

                    return $f->showForm();
                break;
                case 1:
                    if(!$cat_id) return '';

                    // Check Rights
                    if(!$parser->getUserId()) return $parser->gt('not_perms');
                    $perm = $parser->checkPerms('wwf_rights_adj');
                    if(!$perm['r']) return $parser->gt('not_perms');
                    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
                    $w = new wAjaxGrid();
                    $w->en_mainmenu = false;
                    $w->edit_table_alias = 'o';

                    $w->f = new wworkflow_models_conns();
                    $w->caption = $parser->gt('connections');
                    $w->f->wfid = $parser->utils->getFieldFromSql('SELECT wfid FROM wwf_wftrans WHERE id='.$cat_id, '');
                    $w->q->select('o.id',  $parser->gt('id'));
                    $w->q->select('f.trcode AS fcode', $parser->gt('code'));
                    $w->q->select('f.title AS ftitle', $parser->gt('fromtrans'));
                    $w->q->select('t.trcode AS tcode', $parser->gt('code'));
                    $w->q->select('t.title AS ttitle', $parser->gt('totrans'));
                    $w->q->from('wwf_conns o');
                    $w->q->from('wwf_wftrans f');
                    $w->q->from('wwf_wftrans t');
                    $w->q->where("o.id<>'0'");
                    $w->q->where("o.fromtrans=f.id");
                    $w->q->where("o.totrans=t.id");
                    $w->q->where("(o.totrans='".$cat_id."') OR (o.fromtrans='".$cat_id."')");
                    $w->q->orderby('o.id');
                    $w->f->extra_deleteAll_sql .= "AND ((totrans='".$cat_id."') OR (fromtrans='".$cat_id."')) ";

                    $w->f->setFieldVal('totrans', $cat_id);
                    $w->f->setFieldVal('fromtrans', $cat_id);
                    $rn = $parser->utils->getFieldFromSql('SELECT title FROM wwf_wftrans WHERE id='.$cat_id, '');
                    $w->f->setFieldAttr('totrans', 'refval', $rn);
                    $w->f->setFieldAttr('fromtrans', 'refval', $rn);
                    //$w->f->setFieldAttr('totrans', 'ro', true);

                    $w->addSearchField('o.id', $parser->gt('name'), 'C');

                    $w->editing = $perm['u'];
                    $w->adding = $perm['c'];
                    $w->copying = $perm['c'];
                    $w->deleting = $perm['d'];
                    $w->multiselect = $perm['d'];

                    $w->addHidden('active_tab', $active_tab);
                    $w->addHidden('cat_id', $cat_id);
                    $w->addHidden('callbackfunc', $callbackfunc);

                    $w->show();

                break;
                case 2: // files
                    if(!$cat_id) return '';
                    include_once(SYS_BASE_PATH.'main/utils/fileman.class.php');
                    $w = new wcat();
                    $w->workframe = 'gridframe';
                    $w->cat_id = $cat_id;
                    $w->active_tab = $active_tab;
                    $w->objtype = 'wwf_wftrans';
                    $w->startpath_org = 'userdata/modules/wworkflow/wwf_wftrans';
                    $w->startpath = $w->startpath_org.'/';
                    $w->autocreatedir = 1;
                    $w->execute_menu  = $parser->isSuperAdmin();
                    $w->show();
                break;
                case 3: // log
                    $objtype = 'wwf_wftrans';
                    include_once(SYS_BASE_PATH.'main/system/log.php');
                break;
            }
        }
    }

    $cat = new wtablecard('wwf_wftrans');
    $cat->notreeframe = true;
    $cat->navigation = true;
    $cat->navibuttons = true;
    $cat->extra_from = '';
    $cat->extra_where = '';
    $cat->adding = $perm['c'];
    $cat->deleting = $perm['d'];
    $cat->perm = $perm;

    $cat->showTable(0);

?>