<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class wworkflow_models_conns extends wPrototype
{
public $wfid = 0;
public function __construct($objtype = '', $id = '')
{
    parent::__construct('wwf_conns');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
}



protected function _onBeforeShowForm()
{
    global $parser;
    if($this->id)
    {
        $this->setFieldAttr('fromtrans', 'ro', 1);
        $this->setFieldAttr('totrans', 'ro', 1);
    }
    $this->setFieldAttr('fromtrans', 'extra_pars', "AND wfid=".$this->wfid);
    $this->setFieldAttr('totrans', 'extra_pars', "AND wfid=".$this->wfid);

    return '';
}

protected function _onBeforeInsert()
{
    global $parser;
    if(($this->getFieldNewVal('fromtrans') == $this->getFieldNewVal('totrans'))
        or !$this->getFieldNewVal('fromtrans') or !$this->getFieldNewVal('totrans')) return $parser->gt('incorrecttrans');
    $parser->conn->Execute('DELETE FROM wwf_conns WHERE fromtrans='.$this->getFieldNewVal('fromtrans').' AND totrans='.$this->getFieldNewVal('totrans'));
    return '';
}

protected function _onInsert()
{
    $this->calc();
    return '';
}

protected function _onDelete()
{
    $this->calc();
    return '';
}

protected function calc()
{
    global $parser;

    $qty = $parser->utils->getFieldFromSql('SELECT COUNT(*) FROM wwf_conns WHERE fromtrans='.$this->getFieldNewVal('fromtrans'), 0);
    $parser->conn->Execute('UPDATE wwf_wftrans SET outputarcs='.$qty.' WHERE id='.$this->getFieldNewVal('fromtrans'));
    $qty = $parser->utils->getFieldFromSql('SELECT COUNT(*) FROM wwf_conns WHERE totrans='.$this->getFieldNewVal('totrans'), 0);
    $parser->conn->Execute('UPDATE wwf_wftrans SET inputarcs='.$qty.' WHERE id='.$this->getFieldNewVal('totrans'));
    return '';
}


}

?>