<?php

    $wfid = (isset($_REQUEST['wfid'])) ? $_REQUEST['wfid'] : 0;

    include_once(SYS_BASE_PATH.'main/classes/workflow.class.php');
    class wwf extends wAjaxWorkFlow
    {
        public $workflowid = 0;
        public function getXml($trans = 0)
        {
            $f = new wworkflow_models_wflow();
            $f->id = $this->workflowid;
            return $f->getXml($trans);
        }
        public function boxMove($formid = 0, $leftcorner = 0, $topcorner = 0, $boxwidth = 0, $boxheight = 0)
        {
            $f = new wworkflow_models_wftrans();
            $f->id = $formid;
            $f->read();
            $f->setFieldNewVal('topcorner', floor($topcorner));
            $f->setFieldNewVal('leftcorner', floor($leftcorner));
            $f->setFieldNewVal('boxwidth', floor($boxwidth));
            $f->setFieldNewVal('boxheight', floor($boxheight));
            $f->update();
            return '';
        }
    }

    $perm = $parser->checkPerms('wwf_rights_adj');
    if(!$perm['r']) return $parser->gt('not_perms');
    $parent =  (isset($_POST["parent"])) ? $_POST["parent"] : 0;

    $w = new wwf('wwf_wftrans', 'wwf_conns');

    $name = $parser->utils->getFieldFromSql('SELECT title FROM wwf_wflow WHERE id='.$wfid, '');
    $w->caption = $name;
    $w->workflowid = $wfid;
    $w->f = new wworkflow_models_wftrans();
    $w->f->setFieldVal('wfid', $wfid);
    $w->f->setFieldAttr('wfid', 'refval', $name);
    $w->f->setFieldAttr('wfid', 'ro', true);

    $name = $parser->utils->getFieldFromSql('SELECT title FROM wwf_wftrans WHERE id='.$parent, '');
    $w->c = new wworkflow_models_conns();
    $w->c->wfid = $wfid;
    $w->c->setFieldVal('fromtrans', $parent);
    $w->c->setFieldAttr('fromtrans', 'refval', $name);
    $w->c->setFieldVal('totrans', $parent);
    $w->c->setFieldAttr('totrans', 'refval', $name);

    $w->editing = $perm['u'];
    $w->adding = $perm['c'];
    $w->copying = $perm['c'];
    $w->deleting = $perm['d'];
    $w->resizable = $perm['u'];
    $w->draggable = $perm['u'];

    $w->addHidden('wfid', $wfid);

    $w->cardurl = $parser->makeUrl('wwf_wftrans_card');

    $w->show();


?>