<?php
        // Check Rights
        if(!$parser->getUserId()) die($parser->gt('not_perms'));
        $perm = $parser->checkPerms('wwf_rights_control');
        if(!$perm['r']) die($parser->gt('not_perms'));
        include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
        $w = new wAjaxGrid();
        $filter_state = (isset($_REQUEST['filter_state'])) ? $_REQUEST['filter_state'] : '';
        $filter_color = (isset($_REQUEST['filter_color'])) ? $_REQUEST['filter_color'] : '';
        $filter_period = (isset($_REQUEST['filter_period'])) ? $_REQUEST['filter_period'] : 1;

        $w->f = new wworkflow_models_wfcase();
        $w->edit_table_alias = 'o';
        //$w->caption = $parser->gt('wwf_wfcase', __FILE__);
        $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wwf_wfcase'", '');

        $w->q->select('o.id',  $parser->gt('id'));
        $wf_col = $w->q->select('b.title', $parser->gt('workflow'), array('func' => 'open_doccard'));
        $w->q->lselect('u.name AS uname', $parser->gt('user'));
        $w->q->lselect('s.name AS sname', $parser->gt('state'));
        $wfid_col = $w->q->select('o.wfid', $parser->gt('workflow'), array('hide' => 1));
        $w->q->from('wwf_wfcase o');
        $w->q->from('wwf_wflow b');
        $w->q->from('sys_objects u');
        $w->q->from('sys_objects s');
        $w->q->where("o.id<>'0'");
        $w->q->where("o.wfid=b.id");
        $w->q->where("o.creatby=u.objid");
        $w->q->where("o.state=s.objid");
        $w->q->orderby('o.id');


        $w->rowclass_col = $w->q->select('o.color', $parser->gt('color'), array('hide' => 1));
        if($filter_color)
        {
            $w->q->where("o.color='".$filter_color."'");
            $w->f->extra_deleteAll_sql .= "AND color='".$filter_color."' ";
            $w->f->setFieldVal('color', $filter_color);
        }
        $w->q->select('o.creaton', $parser->gt('createdon'));
        if($filter_period)
        {
             $per = $parser->utils->getPeriod($filter_period, true);
             $w->q->where("o.creaton ".$per);
             $w->f->extra_deleteAll_sql .= "AND (creaton ".$per.")";
        }
        if($filter_state)
        {
            $w->q->where("o.state='".$filter_state."'");
            $w->f->extra_deleteAll_sql .= "AND state='".$filter_state."' ";
            $w->f->setFieldVal('state', $filter_state);
        }
        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_period';
        $pars['val'] = $filter_period;
        $w->addCell($parser->utils->periodMenu($pars));

        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_color';
        $pars['val'] = $filter_color;
        $pars['colored'] = true;
        $pars['options'] = array($parser->gt('allcolors'));
        //$pars['sql'] = 'SELECT objid, name_'.$parser->lang_suff." FROM sys_objects WHERE objtype='sys_interface_colors' ORDER BY name_".$parser->lang_suff;
        $w->addCell($parser->utils->dropdownMenu($pars));


        $w->popup_script = true;
        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_state';
        $pars['emptyval'] = 0;
        $pars['tree_btn'] = 0;
        $pars['emptyrefval'] = $parser->gt('all');
        $pars['val'] = $filter_state;
        $pars['objtype'] = 'wwf_dirs_casest';
        $w->addCell($parser->utils->finder($pars));

        $w->addSearchField('o.id', $parser->gt('name'), 'C');

        $w->editing = $perm['u'];
        $w->adding = $perm['c'];
        $w->copying = $perm['c'];
        $w->deleting = $perm['d'];
        $w->multiselect = $perm['d'];


        $w->cardurl = $parser->makeUrl('wwf_wfcase_card');
        $src = "<script type=\"text/javascript\">
        function open_doccard(id, i, idx)
        {
            openWinc('".$parser->makeUrl('wwf_wfcase_card')."', 'callbackfunc=self.opener.global_".$w->container.".reReadRow(' + idx + ')&objid=' + id);
        }
        </script>";
        $parser->addScript($src);


        $w->show();
?>