<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wwf_rights_adj');
    if(!$perm['r']) die($parser->gt('not_perms'));

    include_once(SYS_BASE_PATH.'main/classes/wcatalog.class.php');
    class wtablecard extends wCatalog
    {
        public $perm = array('c' => 0, 'r' => 0, 'u' => 0, 'd' => 0);
        public function _titleframe()
        {
            global $parser;
            $this->title = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wwf_wflow'", '');
            $this->f = new wworkflow_models_wflow();
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;
            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';
            $this->addHidden('callbackfunc', $callbackfunc);
            $this->addMenu(0, $parser->gt('card'), !$active_tab);
            $this->addMenu(1, $parser->gt('transitions'), ($active_tab == 1));
            $this->addMenu(2, $parser->gt('connections'), ($active_tab == 2));
            $this->addMenu(3, $parser->gt('scheme'), ($active_tab == 3));
            $this->addMenu(4, $parser->gt('log'), ($active_tab == 4));
        }

        public function _content()
        {
            global $parser;
            $cat_id = (isset($_REQUEST['cat_id'])) ? $_REQUEST['cat_id'] : '';
            $objid = (isset($_REQUEST['objid'])) ? $_REQUEST['objid'] : '';
            $card_onload_par = (isset($_REQUEST['card_onload_par'])) ? $_REQUEST['card_onload_par'] : '';
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : '';
            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';
            if(!$this->adding and !$cat_id) return $parser->gt('no_data_found');

            switch($active_tab)
            {
                case 0:
                    $parser->addScript(SYS_BASE_URL.'main/js/popup.js');

                    $f = new wworkflow_models_wflow($this->objtype, $cat_id);
                    $f->id = $cat_id;
                    $f->buttonpanel = 'buttonpanelm';
                    $f->only_card = true;
                    $f->container = 'wwf_wflow_cat';
                    $form_action = (isset($_POST['form_action'])) ? $_POST['form_action'] : '';
                    switch($form_action)
                    {
                        case 'edit':
                            $f->read();
                            $s = $f->update(true);
                            if($s) $f->error_mess = $s;
                            if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                        break;
                        case 'insert':
                            $s = $f->insert(true);
                            if($s) $f->error_mess = $s;
                            else
                            {
                                if($card_onload_par) $f->onCopy($card_onload_par);
                                if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                                return "<SCRIPT LANGUAGE=\"JavaScript\">navigatetoid('".$f->id."');</SCRIPT>";
                            }
                        break;
                    }

                    $f->addHidden('cat_id', $cat_id);
                    $f->addHidden('active_tab', $active_tab);
                    $f->addHidden('callbackfunc', $callbackfunc);
                    $parser->addScript("<script type='text/javascript'>
                    function form_submit()
                    {
                        $('#form_dialog_".$f->container."').submit();
                    }
                    </script>");
                    $f->en_autocomplete = true;
                    if($cat_id)
                    {
                        if($this->perm['u'])
                        {
                            $f->addHidden('form_action', 'edit');
                            $f->addButton($parser->gt('save'), 'form_submit()', 'submitbutton', 'button');
                        }
                    } else
                    {
                        if($this->perm['c'])
                        {
                            if($card_onload_par) $f->onBeforeCopy($card_onload_par);
                            $f->addHidden('form_action', 'insert');
                            $f->addHidden('card_onload_par', $card_onload_par);
                            $f->addButton($parser->gt('insert'), 'form_submit()', 'submitbutton', 'button');
                            $f->addButton($parser->gt('cancel'), "navigateto('last')", '', 'button');
                        }
                    }

                    return $f->showForm();
                break;
                case 1:
                    if(!$cat_id) return '';

                    // Check Rights
                    if(!$parser->getUserId()) return $parser->gt('not_perms');
                    $perm = $parser->checkPerms('wwf_rights_adj');
                    if(!$perm['r']) return $parser->gt('not_perms');

                    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
                    $w = new wAjaxGrid();
                    $w->en_mainmenu = false;
                    $w->edit_table_alias = 'o';

                    $w->f = new wworkflow_models_wftrans();
                    $w->caption = $parser->gt('transitions');

                    $w->q->select('o.id',  $parser->gt('id'));
                    $w->q->select('o.trcode', $parser->gt('code'), array('edit' => $perm['u']));
                    $w->q->select('o.title', $parser->gt('name'), array('edit' => $perm['u']));
                    $w->q->lselect('t.name', $parser->gt('triggertype'));
                    $w->q->lselect('ts.name', $parser->gt('trtask'));
                    $w->q->lselect('r.name', $parser->gt('role'));
                    $w->q->lselect('u.name', $parser->gt('user'));
                    $w->q->select('o.inputarcs',  $parser->gt('inputarcs'));
                    $w->q->select('o.outputarcs',  $parser->gt('outputarcs'));
                    $w->q->from('wwf_wftrans o');
                    $w->q->from('sys_objects t');
                    $w->q->from('sys_objects ts');
                    $w->q->from('sys_objects r');
                    $w->q->from('sys_objects u');
                    $w->q->where("o.id<>'0'");
                    $w->q->where("o.triggertype=t.objid");
                    $w->q->where("o.taskid=ts.objid");
                    $w->q->where("o.roleid=r.objid");
                    $w->q->where("o.userid=u.objid");
                    $w->q->where("o.wfid='".$cat_id."'");
                    $w->q->orderby('o.trcode');
                    $w->q->orderby('o.title');
                    $w->f->extra_deleteAll_sql .= "AND wfid='".$cat_id."' ";

                    $w->f->setFieldVal('wfid', $cat_id);
                    $w->f->setFieldAttr('wfid', 'refval', $parser->utils->getFieldFromSql('SELECT title FROM wwf_wflow WHERE id='.$cat_id, ''));
                    $w->f->setFieldAttr('wfid', 'ro', true);
                    $w->addingpars .= 'masterid='.$cat_id;

                    $w->addSearchField('o.title', $parser->gt('name'), 'C');

                    $w->editing = $perm['u'];
                    $w->adding = $perm['c'];
                    $w->copying = $perm['c'];
                    $w->deleting = $perm['d'];
                    $w->multiselect = $perm['d'];

                    $w->cardurl = $parser->makeUrl('wwf_wftrans_card');

                    $w->addHidden('active_tab', $active_tab);
                    $w->addHidden('cat_id', $cat_id);
                    $w->addHidden('callbackfunc', $callbackfunc);

                    $w->show();
                break;
                case 2:
                    if(!$cat_id) return '';

                    // Check Rights
                    if(!$parser->getUserId()) return $parser->gt('not_perms');
                    $perm = $parser->checkPerms('wwf_rights_adj');
                    if(!$perm['r']) return $parser->gt('not_perms');
                    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
                    $w = new wAjaxGrid();
                    $w->en_mainmenu = false;
                    $w->edit_table_alias = 'o';
                    $w->delete_all = false;

                    $w->f = new wworkflow_models_conns();
                    $w->caption = $parser->gt('connections');

                    $w->q->select('o.id',  $parser->gt('id'));
                    $w->q->select('f.trcode AS fcode', $parser->gt('code'));
                    $w->q->select('f.title AS ftitle', $parser->gt('fromtrans'));
                    $w->q->select('t.trcode AS tcode', $parser->gt('code'));
                    $w->q->select('t.title AS ttitle', $parser->gt('totrans'));
                    $w->q->from('wwf_conns o');
                    $w->q->from('wwf_wftrans f');
                    $w->q->from('wwf_wftrans t');
                    $w->q->where("o.id<>'0'");
                    $w->q->where("o.fromtrans=f.id");
                    $w->q->where("o.totrans=t.id");
                    $w->q->where("(f.wfid=".$cat_id.") OR (t.wfid=".$cat_id.")");
                    $w->q->orderby('o.id');

                    $w->addSearchField('o.id', $parser->gt('name'), 'C');

                    $w->editing = $perm['u'];
                    $w->adding = false;
                    $w->copying = false;
                    $w->deleting = $perm['d'];
                    $w->multiselect = $perm['d'];

                    $w->addHidden('active_tab', $active_tab);
                    $w->addHidden('cat_id', $cat_id);
                    $w->addHidden('callbackfunc', $callbackfunc);

                    $w->show();
                break;
                case 3:
                    if(!$cat_id) return '';
                    print("<iframe src=\"".$parser->makeUrl('wwf_wflow_schema', 'wfid='.
                    $cat_id)."\"  style=\"border: 1px solid #c0c0c0;width:100%;height:800px\"></iframe>");
                break;
                case 4: // log
                    $objtype = 'wwf_wflow';
                    include_once(SYS_BASE_PATH.'main/system/log.php');
                break;
            }
        }
    }

    $cat = new wtablecard('wwf_wflow');
    $cat->notreeframe = true;
    $cat->navigation = true;
    $cat->navibuttons = true;
    $cat->extra_from = '';
    $cat->extra_where = '';
    $cat->adding = $perm['c'];
    $cat->deleting = $perm['d'];
    $cat->perm = $perm;

    $cat->showTable(0);

?>