<?php
        // Check Rights
        if(!$parser->getUserId()) die($parser->gt('not_perms'));
        $perm = $parser->checkPerms('wwf_rights_control');
        if(!$perm['r']) die($parser->gt('not_perms'));
        include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');

        $user = $parser->getUserId();

        $cat_id = (isset($cat_id)) ? $cat_id : 0;
        $active_tab = (isset($active_tab)) ? $active_tab : 0;
        $workframe = (isset($workframe)) ? $workframe : 0;

        $w = new wAjaxGrid();
        $filter_state = (isset($_REQUEST['filter_state'])) ? $_REQUEST['filter_state'] : 'sys_operst_en';
        $filter_period = (isset($_REQUEST['filter_period'])) ? $_REQUEST['filter_period'] : 0;
        $action = (isset($_REQUEST['form_action'])) ? $_REQUEST['form_action'] : '';
        $formid = (isset($_REQUEST['formid'])) ? $_REQUEST['formid'] : '';

        $w->f = new wworkflow_models_wfoper();
        switch($action)
        {
            case 'fire':
                if(!$formid) break;
                $w->f->id = $formid;
                $w->mess = $w->f->fire();
            break;
        }

        $w->edit_table_alias = 'o';
        $w->caption = $parser->gt('operations', __FILE__);

        $w->q->select('o.id',  $parser->gt('id'));
        $GLOBALS['casecol_col'] = $casecol_col = $w->q->select('o.caseid',  $parser->gt('process'));
        $w->q->select('tr.trcode', $parser->gt('code'));
        $w->q->select('tr.title', $parser->gt('name'));
        $w->q->lselect('t.name AS tname', $parser->gt('triggertype'));
        $w->q->select('ts.name AS tsname', $parser->gt('trtask'), array('lang' => 1, 'html' => 1, 'calc' => ($perm['u']) ? 'show_task' : ''));
        $w->q->lselect('r.name AS rname', $parser->gt('role'));
        $w->q->lselect('u.name AS uname', $parser->gt('user'));
        $w->q->select('o.creaton', $parser->gt('createdon'));
        $w->q->select('o.finishon', $parser->gt('finishon'));
        $w->q->select('o.cancelon', $parser->gt('cancelon'));
        $w->q->select('o.timeout', $parser->gt('timeout'));
        $w->q->lselect('s.name AS sname', $parser->gt('status'));
        $w->q->select('o.state', $parser->gt('action'), array('html' => 1, 'calc' => ($perm['u']) ? 'fire_trans' : ''));
        $GLOBALS['shortcycle_col'] = $w->q->select('tr.shortcycle', $parser->gt('shortcycle'), array('hide' => 1));
        $GLOBALS['subwfid_col'] = $w->q->select('tr.subwfid', $parser->gt('subwfid'), array('hide' => 1));
        $GLOBALS['objtype_col'] = $w->q->select('c.objtype', $parser->gt('objtype'), array('hide' => 1));
        $GLOBALS['objid_col'] = $w->q->select('c.objid', $parser->gt('objid'), array('hide' => 1));
        $GLOBALS['taskid_col'] = $w->q->select('tr.taskid', $parser->gt('taskid'), array('hide' => 1));
        $GLOBALS['taskpage_col'] = $w->q->select('ts.ref1 AS trref1', $parser->gt('taskidref1'), array('hide' => 1));
        $w->q->from('wwf_wfoper o');
        $w->q->from('wwf_wfcase c');
        $w->q->where("o.id<>'0'");
        $w->q->where("o.caseid=c.id");
        $w->q->where("o.transid=tr.id");
        $w->q->from('wwf_wftrans tr');
        $w->q->from('sys_objects t');
        $w->q->from('sys_objects ts');
        $w->q->from('sys_objects r');
        $w->q->from('sys_objects u');
        $w->q->from('sys_objects s');
        $w->q->where("tr.triggertype=t.objid");
        $w->q->where("tr.taskid=ts.objid");
        $w->q->where("tr.roleid=r.objid");
        $w->q->where("tr.userid=u.objid");
        $w->q->where("o.state=s.objid");
        $w->q->orderby('o.id');

        // Check rights
        if(!$parser->isSuperAdmin())
        $w->q->where("(
        ((tr.roleid=0) AND (tr.userid=0))
         OR (tr.userid='".$user."')
         OR (tr.roleid IN (".$_SESSION['user_roles']."))
        )");

        if($filter_period and !$cat_id)
        {
             $per = $parser->utils->getPeriod($filter_period, true);
             $w->q->where("o.creaton ".$per);
             $w->f->extra_deleteAll_sql .= "AND (creaton ".$per.")";
        }
        if($filter_state)
        {
            $w->q->where("o.state='".$filter_state."'");
            $w->f->extra_deleteAll_sql .= "AND state='".$filter_state."' ";
            $w->f->setFieldVal('state', $filter_state);
        }
        if(!$cat_id)
        {
            $pars = array();
            $pars['onchange'] = $w->container."_postAction('',0)";
            $pars['name'] = 'filter_period';
            $pars['val'] = $filter_period;
            $w->addCell($parser->utils->periodMenu($pars));
        } else
        {
            $w->q->where("o.caseid='".$cat_id."'");
            $w->f->setFieldVal('caseid', $cat_id);
            $w->f->setFieldAttr('caseid', 'refval', $parser->utils->getFieldFromSql('SELECT id FROM wwf_wfcase WHERE id='.$cat_id, ''));
            $w->f->setFieldAttr('caseid', 'ro', true);
        }
        $w->popup_script = true;
        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_state';
        $pars['emptyval'] = 0;
        $pars['tree_btn'] = 0;
        $pars['emptyrefval'] = $parser->gt('allstates');
        $pars['val'] = $filter_state;
        $pars['objtype'] = 'sys_operstates';
        $w->addCell($parser->utils->finder($pars));

        $w->addSearchField('tr.title', $parser->gt('name'), 'C');

        $w->editing = $perm['u'];

        $w->cardurl = $parser->makeUrl('wwf_wfoper_card');
        $w->addCard($casecol_col, $casecol_col, $parser->makeUrl('wwf_wfcase_card'), 'active_tab=2');

        $w->addHidden('active_tab', $active_tab);
        $w->addHidden('cat_id', $cat_id);
        $w->addHidden('workframe', $workframe);

        $GLOBALS['container'] = $w->container;

        function fire_trans($rs,$i,$v,$obj)
        {
            global $parser, $shortcycle_col, $subwfid_col, $container;
            $s = '';
            switch($v)
            {
                case 'sys_operst_en': $s = ($rs->fields[$shortcycle_col]) ? 'completeoper' : 'opertowork'; break;
                case 'sys_operst_inwork': if(!$subwfid_col) $s = 'completeoper';
            }
            if(!$s) return '';
            return "<a href=\"#\" onclick=\"".$container."_postAction('fire', '".$rs->fields[0]."'); return false\" title=\"\">".$parser->gt($s)."</a>";
        }

        function show_task($rs,$i,$v,$obj)
        {
            global $parser, $objtype_col, $objid_col, $taskid_col, $casecol_col, $taskpage_col;
            if(!$rs->fields[$taskid_col]) return $v;
            return "<a href=\"#\" onclick=\"openWinc('".$parser->makeUrl($rs->fields[$taskpage_col]).
                    "', 'caseid=".$rs->fields[$casecol_col]."&caseoperid=".$rs->fields[0].
                    "&master_objtype=".$rs->fields[$objtype_col]."&master_objid=".$rs->fields[$objid_col].
                    "'); return false\" title=\"\">".$v."</a>";
        }

        $w->show();
?>