<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class wworkflow_models_wftrans extends wPrototype
{

public function __construct($objtype = '', $id = '')
{
    parent::__construct('wwf_wftrans');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
}


protected function _onBeforeInsert()
{
    global $parser;
    if(in_array($this->getFieldNewVal('triggertype'), array('sys_triggers_time','sys_triggers_ext'))) $this->setFieldNewVal('shortcycle', 1);
    if($this->getFieldNewVal('subwfid')) $this->setFieldNewVal('shortcycle', 0);
    $this->setFieldNewVal('inputarcs', 0);
    $this->setFieldNewVal('outputarcs', 0);
    return '';
}

protected function _onBeforeUpdate()
{
    global $parser;
    if(in_array($this->getFieldNewVal('triggertype'), array('sys_triggers_time','sys_triggers_ext'))) $this->setFieldNewVal('shortcycle', 1);
    if($this->getFieldNewVal('subwfid')) $this->setFieldNewVal('shortcycle', 0);
    return '';
}

protected function _onDelete()
{
    global $parser;
    $fn = SYS_BASE_PATH.'userdata/modules/wworkflow/wwf_wftrans/'.$this->id;
    if(file_exists($fn)) $parser->utils->removeDir($fn, true);
    return '';
}

}

?>